Subject: Re: [net-next PATCH v3 3/8] net: sched: add cls_u32 offload hooks for netdevs

From: John Fastabend <[email-masked]>
Date: Wed, 17 Feb 2016 15:07:23 -0800

[...]

>>
>>> +static void u32_replace_hw_hnode(struct tcf_proto *tp, struct
>>> tc_u_hnode *h)
>>> +{
>>> +    struct net_device *dev = tp->q->dev_queue->dev;
>>> +    struct tc_cls_u32_offload u32_offload = {0};
>>> +    struct tc_to_netdev offload;
>>> +
>>> +    offload.type = TC_SETUP_CLSU32;
>>> +    offload.cls_u32 = &u32_offload;
>>> +
>>> +    if (dev->netdev_ops->ndo_setup_tc) {
>>> +        offload.cls_u32->command = TC_CLSU32_NEW_HNODE;
>>
>> TC_CLSU32_REPLACE_HNODE?
>>
> 
> Yep I made this change and will send out v4.
> 
> [...]
> 
>>

Actually thinking about this a bit more I wrote this thinking
that there existed some hardware that actually cared if it was
a new rule or an existing rule. For me it doesn't matter I do
the same thing in the new/replace cases I just write into the
slot on the hardware table and if it happens to have something
in it well its overwritten e.g. "replaced". This works because
the cls_u32 layer protects us from doing something unexpected.

I'm wondering (mostly asking the mlx folks) is there hardware
out there that cares to make this distinction between new and
replace? Otherwise I can just drop new and always use replace.
Or vice versa which is the case in its current form.

Thanks,
John